<template>
  <v-toolbar
    :color="$store.state.primaryColor" dark
    flat
    :extension-height="125"
  >
    <hamburger-close-button v-model="isMinifiedSync" />
    <v-spacer />
    <!-- Renders the title if provided by a  <portal>, or just dezrann-->
    <v-toolbar-title>
      <portal-target
        name="sidebar-title"
        :slot-props="{ isMinified: isMinifiedSync }"
      >
        <span class="real-title">{{ $store.state
          .corpus[$store.state.indexCurrentPiece].getTitle($i18n.locale) }}</span>
      </portal-target>
    </v-toolbar-title>
    <!-- Renders the metadata if provided by a  <portal>-->
    <template v-if="!isMinifiedSync" #extension>
      <v-spacer />
      <v-fade-transition>
        <div style="text-align: right;">
          <portal-target
            name="sidebar-metadata-one"
            :slot-props="{ isMinified: isMinifiedSync }"
          >
            <span>&nbsp;{{ $store.state
              .corpus[$store.state.indexCurrentPiece].getMetadataOne($i18n.locale) }}</span>
          </portal-target>
          <portal-target
            name="sidebar-metadata-two"
            :slot-props="{ isMinified: isMinifiedSync }"
          >
            <span>&nbsp;{{ $store.state
              .corpus[$store.state.indexCurrentPiece].getMetadataTwo($i18n.locale) }}</span>
          </portal-target>
          <portal-target
            name="sidebar-metadata-corpus"
            :slot-props="{ isMinified: isMinifiedSync }"
          >
            <span>&nbsp;{{ $store.state
              .corpus[$store.state.indexCurrentPiece].getMetadataCorpus($i18n.locale) }}</span>
          </portal-target>
          <portal-target
            name="sidebar-icons"
            :slot-props="{ isMinified: isMinifiedSync }"
          >
            <v-icon
              size="big"
              class="not-available"
            >
              mdi-skip-previous
            </v-icon>
            <v-icon
              size="small"
              class="not-available"
            >
              mdi-information-outline
            </v-icon>
            <v-icon
              size="big"
              class="not-available"
            >
              mdi-skip-next
            </v-icon>
          </portal-target>
          <portal-target
            name="sidebar-refs"
            :slot-props="{ isMinified: isMinifiedSync }"
          >
            <ref-links
              v-if="Object.keys($store.state
                .corpus[$store.state.indexCurrentPiece].refs).length > 0"
              :refs="$store.state
                .corpus[$store.state.indexCurrentPiece].refs"
            />
            <br v-else>
          </portal-target>
        </div>
      </v-fade-transition>
    </template>
  </v-toolbar>
</template>
<script lang="ts">
import {
  Vue, Component, PropSync,
} from 'vue-property-decorator';
import { Wormhole } from 'portal-vue';
import HamburgerCloseButton from './buttons/HamburgerCloseButton.vue';
import RefLinks from './RefLinks.vue';

@Component({
  components: {
    HamburgerCloseButton,
    RefLinks,
  },
})
export default class Sidebar extends Vue {
  @PropSync('isMinified', { default: false })
  isMinifiedSync!: boolean;

  // Check if the current page defines a sidebar subtitle
  // Necessary because we should not create an #extension slot at all
  //  if a subtitle is not available
  isSubtitleAvailable(): boolean {
    return Wormhole.hasContentFor('sidebar-subtitle');
  }
}
</script>
<style scoped lang="scss">
.real-title {
  display: inline-block;
  text-align: right;
  width: 300px;
  overflow: clip;
  text-overflow: ellipsis;
}
.not-available {
  color: rgba(255, 255, 255, 0.2);
}
</style>
